commit 753cd5f36158e0c99e25b171b2e44e2fbe86a064
Author: Giuliano Belinassi <gbelinassi@suse.de>
Date:   Tue Nov 16 17:25:32 2021

    Do not abort compilation when dump file is /dev/*
    
    The `configure` scripts generated with autoconf often tests compiler
    features by setting output to `/dev/null`, which then sets the dump
    folder as being /dev/* and the compilation halts with an error because
    GCC cannot create files in /dev/. This is a problem when configure is
    testing for compiler features because it cannot tell if the failure was
    due to unsupported features or any other problem, and disable it even
    if it is working.
    
    As an example, running configure overriding CFLAGS="-fdump-ipa-clones"
    will result in several compiler-features as being disabled because of
    gcc halting with an error creating files in /dev/*.
    
    This commit fixes this issue by checking if the output file is
    /dev/null or /dev/zero. In this case we use the current working
    directory for dump output instead of the directory of the output
    file because we cannot write to /dev/*.
    
    gcc/ChangeLog
    2021-11-16  Giuliano Belinassi  <gbelinassi@suse.de>
    
            * gcc.c (process_command): Skip dumpdir override if file is a
            not_actual_file_p.
            * doc/invoke.texi: Update -dumpdir documentation.
    
    gcc/testsuite/ChangeLog
    2021-11-16  Giuliano Belinassi  <gbelinassi@suse.de>
    
            * gcc.dg/devnull-dump.c: New.
    
            (cherry-picked from commit c7381debe4c5dd7878338f38db98face1cfa6f90)

diff --git a/gcc/gcc.c b/gcc/gcc.c
index 4d790f9dd4a..8ba410c9e17 100644
--- a/gcc/gcc.c
+++ b/gcc/gcc.c
@@ -4991,7 +4991,8 @@ process_command (unsigned int decoded_options_count,
 
   bool explicit_dumpdir = dumpdir;
 
-  if (!save_temps_overrides_dumpdir && explicit_dumpdir)
+  if ((!save_temps_overrides_dumpdir && explicit_dumpdir)
+      || (output_file && not_actual_file_p (output_file)))
     {
       /* Do nothing.  */
     }
diff --git a/gcc/testsuite/gcc.dg/devnull-dump.c b/gcc/testsuite/gcc.dg/devnull-dump.c
new file mode 100644
index 00000000000..378e0901c28
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/devnull-dump.c
@@ -0,0 +1,7 @@
+/* { dg-do assemble } */
+/* { dg-options "-fdump-ipa-clones -o /dev/null" } */
+
+int main()
+{
+  return 0;
+}

